package com.tew.persistence;


import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import com.tew.model.Alumno;


/**
 * Implementaci??n de la interfaz de fachada al servicio de persistencia para
 * Alumnos. En este caso es Jdbc pero podr??a ser cualquier otra tecnologia 
 * de persistencia, por ejemplo, JPA, Hibernate, IBatis 
 * 
 * @author Enrique
 *
 */
public class AlumnoDao {

	public List<Alumno> getAlumnos() throws Exception {
		PreparedStatement ps = null;
		ResultSet rs = null;
		Connection con = null;
		
		List<Alumno> alumnos = new ArrayList<Alumno>();

		try {
			// En una implementaci??n m??s sofisticada estas constantes habr??a 
			// que sacarlas a un sistema de configuraci??n: 
			// xml, properties, descriptores de despliege, etc 
			String SQL_DRV = "org.hsqldb.jdbcDriver";
			String SQL_URL = "jdbc:hsqldb:hsql://localhost";

			// Obtenemos la conexi??n a la base de datos.
			Class.forName(SQL_DRV);
			con = DriverManager.getConnection(SQL_URL, "sa", "");
			ps = con.prepareStatement("select * from alumno");
			rs = ps.executeQuery();

			while (rs.next()) {
				Alumno alumno = new Alumno();
				alumno.setNombre(rs.getString("NOMBRE"));
				alumno.setApellidos(rs.getString("APELLIDOS"));
				alumno.setEmail(rs.getString("EMAIL"));
				alumno.setIdUser(rs.getString("IDUSER"));
				
				alumnos.add(alumno);
			}
		}
		finally  {
			if (rs != null) {try{ rs.close(); } catch (Exception ex){}};
			if (ps != null) {try{ ps.close(); } catch (Exception ex){}};
			if (con != null) {try{ con.close(); } catch (Exception ex){}};
		}
		
		return alumnos;
	}

	public void delete(Alumno a) throws Exception {
		// TODO Auto-generated method stub
	}

	public Alumno findById(int id) throws Exception {
		// TODO Auto-generated method stub
		return null;
	}

	public void save(Alumno a) throws Exception {
		// TODO Auto-generated method stub
	}

	public void update(Alumno a) throws Exception {
		// TODO Auto-generated method stub
	}

}
